library ieee;
use ieee.std_logic_1164.all;

entity DetectorDePulsos is
    port(
            clk: in std_logic; 
            reset: in std_logic; 
            Boton_A: in std_logic; 
            Boton_B: in std_logic; 
            Led: out std_logic
);

end DetectorDePulsos;

architecture structural of DetectorDePulsos is

--Declaracion de componente antirebotes. 
--Aunque utilice dos antirebotes solo tengo que declaralo una vez
    component Antirebotes is
        Port (
                clk: in STD_LOGIC; 
                reset : in std_logic; 
                boton : in STD_LOGIC;
                filtrado : out STD_LOGIC
    );
    end component;
    
--Declaracion del componente "FSM" 
    component FSM is
        port(
            clk: in STD_LOGIC; 
            reset : in std_logic; 
            A : in STD_LOGIC; 
            B : in STD_LOGIC;
            LED : out STD_LOGIC
        );
    end component;

--Declaracion seales internas 
    signal filtrado_A: std_logic;
    signal filtrado_B: std_logic;


 
begin
 
    anti_a: Antirebotes port map( 
                                    clk=>clk, 
                                    reset=>reset,
                                    boton=>Boton_A, 
                                    filtrado=>filtrado_A
                                  );

    anti_b: Antirebotes port map( 
                                    clk=>clk, 
                                    reset=>reset,
                                    boton=>Boton_B, 
                                    filtrado=>filtrado_B
                                );

    fsm_secue: FSM port map( 
                                    clk=>clk, 
                                    reset=>reset, 
                                    A=>filtrado_A,
                                    B=>filtrado_B,
                                    LED=>Led
                                );
end structural;